| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Functions
Printer Class Device Mode Driver
Printer Class Driver

## Data Structures
struct | USB_ClassInfo_PRNT_Device_t
| Printer Class Device Mode Configuration and State Structure. More...

## Functions
void | EVENT_PRNT_Device_SoftReset (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint16_t | PRNT_Device_BytesReceived (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
bool | PRNT_Device_ConfigureEndpoints (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | PRNT_Device_CreateBlockingStream (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo, FILE *const Stream) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
void | PRNT_Device_CreateStream (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo, FILE *const Stream) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | PRNT_Device_Flush (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | PRNT_Device_ProcessControlRequest (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
int16_t | PRNT_Device_ReceiveByte (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Device_SendByte (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo, const uint8_t Data) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Device_SendData (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo, const void *const Buffer, const uint16_t Length) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | PRNT_Device_SendString (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo, const char *const String) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
void | PRNT_Device_USBTask (USB_ClassInfo_PRNT_Device_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LUFA/Drivers/USB/Class/Device/PrinterClassDevice.c (Makefile source module name: LUFA_SRC_USBCLASS)

# Module Description

Device Mode USB Class driver framework interface, for the Printer USB Class driver.

## Function Documentation

void EVENT_PRNT_Device_SoftReset | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

Printer class driver event for a soft reset request on a Printer interface. This event fires each time the host requests a reset of the printer interface's internal state, and may be hooked in the user program by declaring a handler function with the same name and parameters listed here.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.

uint16_t PRNT_Device_BytesReceived | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

Determines the number of bytes received by the Printer interface from the host, waiting to be read. This indicates the number of bytes in the OUT endpoint bank only, and thus the number of calls to PRNT_Device_ReceiveByte() which are guaranteed to succeed immediately. If multiple bytes are to be received, they should be buffered by the user application, as the endpoint bank will not be released back to the USB controller until all bytes are read.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.

Returns
  Total number of buffered bytes received from the host.

bool PRNT_Device_ConfigureEndpoints | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

Configures the endpoints of a given Printer interface, ready for use. This should be linked to the library EVENT_USB_Device_ConfigurationChanged() event so that the endpoints are configured when the configuration containing the given Printer interface is selected.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.

Returns
  Boolean `true` if the endpoints were successfully configured, `false` otherwise.

void PRNT_Device_CreateBlockingStream | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Identical to PRNT_Device_CreateStream(), except that reads are blocking until the calling stream function terminates the transfer. While blocking, the USB and Printer service tasks are called repeatedly to maintain USB communications.

Note
  This function is not available on all microcontroller architectures.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.
  [in,out] | Stream | Pointer to a FILE structure where the created stream should be placed.

void PRNT_Device_CreateStream | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Creates a standard character stream for the given Printer Device instance so that it can be used with all the regular functions in the standard <stdio.h> library that accept a `FILE` stream as a destination (e.g. `fprintf()`). The created stream is bidirectional and can be used for both input and output functions.

Reading data from this stream is non-blocking, i.e. in most instances, complete strings cannot be read in by a single fetch, as the endpoint will not be ready at some point in the transmission, aborting the transfer. However, this may be used when the read data is processed byte-per-bye (via `getc()`) or when the user application will implement its own line buffering.

Note
  The created stream can be given as `stdout` if desired to direct the standard output from all `<stdio.h>` functions to the given Printer interface.
  This function is not available on all microcontroller architectures.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.
  [in,out] | Stream | Pointer to a FILE structure where the created stream should be placed.

uint8_t PRNT_Device_Flush | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

Flushes any data waiting to be sent, ensuring that the send buffer is cleared.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.

Returns
  A value from the Endpoint_WaitUntilReady_ErrorCodes_t enum.

void PRNT_Device_ProcessControlRequest | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

Processes incoming control requests from the host, that are directed to the given Printer class interface. This should be linked to the library EVENT_USB_Device_ControlRequest() event.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.

int16_t PRNT_Device_ReceiveByte | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

Reads a byte of data from the host. If no data is waiting to be read of if a USB host is not connected, the function returns a negative value. The PRNT_Device_BytesReceived() function may be queried in advance to determine how many bytes are currently buffered in the Printer interface's data receive endpoint bank, and thus how many repeated calls to this function which are guaranteed to succeed.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.

Returns
  Next received byte from the host, or a negative value if no data received.

uint8_t PRNT_Device_SendByte | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo,
|  | const uint8_t | Data
| ) |  |

Sends a given byte to the attached USB host, if connected. If a host is not connected when the function is called, the byte is discarded. Bytes will be queued for transmission to the host until either the endpoint bank becomes full, or the PRNT_Device_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single endpoint packet, increasing data throughput.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.
  [in] | Data | Byte of data to send to the host.

Returns
  A value from the Endpoint_WaitUntilReady_ErrorCodes_t enum.

uint8_t PRNT_Device_SendData | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo,
|  | const void *const | Buffer,
|  | const uint16_t | Length
| ) |  |

Sends a given data buffer to the attached USB host, if connected. If a host is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the host until either the endpoint bank becomes full, or the PRNT_Device_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single endpoint packet, increasing data throughput.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.
  [in] | Buffer | Pointer to a buffer containing the data to send to the device.
  [in] | Length | Length of the data to send to the host.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t PRNT_Device_SendString | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo,
|  | const char *const | String
| ) |  |

Sends a given null terminated string to the attached USB host, if connected. If a host is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the host until either the endpoint bank becomes full, or the PRNT_Device_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single endpoint packet, increasing data throughput.

Precondition
  This function must only be called when the Device state machine is in the DEVICE_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.
  [in] | String | Pointer to the null terminated string to send to the host.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

void PRNT_Device_USBTask | ( | USB_ClassInfo_PRNT_Device_t *const | PRNTInterfaceInfo | ) |

General management task for a given Printer class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class configuration and state.